import ts from "typescript";
export const traverse = (create) => (context) => (rootNode) => {
    const visit = (node) => {
        if (!ts.isSourceFile(node)) {
            return node;
        }
        return context.factory.updateSourceFile(node, create(context), node.isDeclarationFile, node.referencedFiles, node.typeReferenceDirectives, node.hasNoDefaultLib, node.libReferenceDirectives);
    };
    return ts.visitNode(rootNode, visit);
};
//# sourceMappingURL=traverse.js.map