import ts from "typescript";
import type { OpenApi } from "../../../types";
import { Factory } from "../../TsGenerator";
import * as ConvertContext from "../ConverterContext";
import * as ToTypeNode from "../toTypeNode";
import type { ArraySchema, ObjectSchema, PrimitiveSchema } from "../types";
import type * as Walker from "../Walker";
export declare const generatePropertySignatures: (entryPoint: string, currentPoint: string, factory: Factory.Type, schema: ObjectSchema, context: ToTypeNode.Context, convertContext: ConvertContext.Types) => ts.PropertySignature[];
export declare const generateInterface: (entryPoint: string, currentPoint: string, factory: Factory.Type, name: string, schema: ObjectSchema, context: ToTypeNode.Context, convertContext: ConvertContext.Types) => ts.InterfaceDeclaration;
export declare const generateArrayTypeAlias: (entryPoint: string, currentPoint: string, factory: Factory.Type, name: string, schema: ArraySchema, context: ToTypeNode.Context, convertContext: ConvertContext.Types) => ts.TypeAliasDeclaration;
export declare const generateTypeAlias: (entryPoint: string, currentPoint: string, factory: Factory.Type, name: string, schema: PrimitiveSchema, convertContext: ConvertContext.Types) => ts.TypeAliasDeclaration;
export declare const generateMultiTypeAlias: (entryPoint: string, currentPoint: string, factory: Factory.Type, name: string, schemas: OpenApi.Schema[], context: ToTypeNode.Context, multiType: "oneOf" | "allOf" | "anyOf", convertContext: ConvertContext.Types) => ts.TypeAliasDeclaration;
export declare const addSchema: (entryPoint: string, currentPoint: string, store: Walker.Store, factory: Factory.Type, targetPoint: string, declarationName: string, schema: OpenApi.Schema | undefined, context: ToTypeNode.Context, convertContext: ConvertContext.Types) => void;
